<template>
  <div v-if="layer">
    <div class="pages">
      <div v-for="(page, i) in layer.pages" :key="i">
        <h4>Page {{ i + 1 }}</h4>
        <el-input
          :value="Math.round(1 / layer.pageScale(page))"
          @input="
            !isNaN(Number($event)) &&
              layer.setPageScale(page, 1 / Number($event))
          "
        >
          <template slot="prepend">Scale:</template>
        </el-input>
      </div>
    </div>
    <el-button v-if="layer.activePage" @click="deletePage">
      Delete Page
    </el-button>
    <el-button v-else-if="!layer.cancelAddPage" @click="addPage">
      Add Page!
    </el-button>
    <span v-else
      >Add page by clicking and dragging an outline.
      <button @click="cancelAddPage">Cancel</button></span
    >
  </div>
  <div v-else>
    <loading-dots />
  </div>
</template>
<style lang="scss" scoped>
@import "~assets/mixins";
.pages {
  padding-bottom: $grid * 0.5;
}
.el-input {
  width: 90%;
  margin: 0 5%;
}
</style>
<script>
export default {
  props: ["value"],
  data() {
    return {
      layer: null,
    };
  },
  mounted() {
    this.$nextTick(this.connectLayer);
  },
  methods: {
    connectLayer() {
      let p = this.$parent;

      while (p && !p.$refs.printConfig) {
        p = p.$parent;
      }

      if (p) {
        this.layer = p.$refs.printConfig;
      } else {
        setTimeout(this.connectLayer, 10);
      }
    },
    addPage() {
      this.layer.addPage();
    },
    deletePage() {
      this.layer.deletePage();
    },
    cancelAddPage() {
      this.layer.cancelAddPage();
    },
  },
};
</script>
